<?php

$REX['SEO42_LANG_PRESETS'] = array(
	array(
		'original_name' => 'české',
		'code' => 'cs',
		'region_code' => 'cs-CZ',
		'url_slug' => 'cs',
		'hreflang' => 'cs',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'À|à|Č|č|ć|È|è|É|é|Ì|ì|Í|í|Ï|ï|Ł|ł|Ò|ò|Ó|ó|Ù|ù|Ú|ú|ź|ż|ž|&',
		'special_chars_rewrite' => 'A|a|C|c|c|E|e|E|e|I|i|I|i|I|i|L|l|O|o|O|o|U|u|U|u|z|z|z|a',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'dansk',
		'code' => 'da',
		'region_code' => 'da-DK',
		'url_slug' => 'da',
		'hreflang' => 'da',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'Å|å|Æ|æ|Ø|ø|É|é|Á|á|&',
		'special_chars_rewrite' => 'Aa|aa|Ae|ae|Oe|oe|E|e|A|a|og',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'deutsch',
		'code' => 'de',
		'region_code' => 'de-DE',
		'url_slug' => 'de',
		'hreflang' => 'de',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'Ä|ä|Ö|ö|Ü|ü|ß|&',
		'special_chars_rewrite' => 'Ae|ae|Oe|oe|Ue|ue|ss|und',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'english',
		'code' => 'en',
		'region_code' => 'en-GB',
		'url_slug' => 'en',
		'hreflang' => 'en',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => '&',
		'special_chars_rewrite' => 'and',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'español',
		'code' => 'es',
		'region_code' => 'es-ES',
		'url_slug' => 'es',
		'hreflang' => 'es',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'Á|á|ç|É|é|Í|í|Ñ|ñ|Ó|ó|Ú|ú|ü|&',
		'special_chars_rewrite' => 'A|a|c|E|e|I|i|N|n|O|o|U|u|u|y',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'française',
		'code' => 'fr',
		'region_code' => 'fr-FR',
		'url_slug' => 'fr',
		'hreflang' => 'fr',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'À|à|Á|á|ç|È|è|É|é|ë|Ì|ì|Í|í|Ï|ï|Ò|ò|Ó|ó|Ù|ù|Ú|ú|&',
		'special_chars_rewrite' => 'A|a|A|a|c|E|e|E|e|e|I|i|I|i|I|i|O|o|O|o|U|u|U|u|et',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'italiano',
		'code' => 'it',
		'region_code' => 'it-IT',
		'url_slug' => 'it',
		'hreflang' => 'it',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'À|à|È|è|É|é|Ì|ì|Í|í|Ï|ï|Ò|ò|Ó|ó|Ù|ù|Ú|ú|&',
		'special_chars_rewrite' => 'A|a|E|e|E|e|I|i|I|i|I|i|O|o|O|o|U|u|U|u|e',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'magyar',
		'code' => 'hu',
		'region_code' => 'hu-HU',
		'url_slug' => 'hu',
		'hreflang' => 'hu',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'Á|á|É|é|Í|í|Ó|ó|Ö|ö|Ő|ő|Ú|ú|Ü|ü|Ű|ű|&',
		'special_chars_rewrite' => 'A|a|E|e|I|i|O|o|O|o|O|o|U|u|U|u|U|u|es',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'nederlands',
		'code' => 'nl',
		'region_code' => 'nl-NL',
		'url_slug' => 'nl',
		'hreflang' => 'nl',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'À|à|È|è|É|é|Ì|ì|Í|í|Ï|ï|Ò|ò|Ó|ó|Ù|ù|Ú|ú|&',
		'special_chars_rewrite' => 'A|a|E|e|E|e|I|i|I|i|I|i|O|o|O|o|U|u|U|u|en',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'norsk',
		'code' => 'no',
		'region_code' => 'no-NO',
		'url_slug' => 'no',
		'hreflang' => 'no',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'Æ|æ|Ø|ø|Å|å|&',
		'special_chars_rewrite' => 'Ae|ae|Oe|oe|A|a|og',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'polska',
		'code' => 'pl',
		'region_code' => 'pl-PL',
		'url_slug' => 'pl',
		'hreflang' => 'pl',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'À|à|Č|č|ć|È|è|É|é|Ì|ì|Í|í|Ï|ï|Ł|ł|Ò|ò|Ó|ó|Ù|ù|Ú|ú|ź|ż|ž|&',
		'special_chars_rewrite' => 'A|a|C|c|c|E|e|E|e|I|i|I|i|I|i|L|l|O|o|O|o|U|u|U|u|z|z|z|i',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'português',
		'code' => 'pt',
		'region_code' => 'pt-PT',
		'url_slug' => 'pt',
		'hreflang' => 'pt',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'À|à|á|ã|ç|È|è|É|é|Ì|ì|Í|í|Ï|ï|Ò|ò|Ó|ó|Ù|ù|Ú|ú|&',
		'special_chars_rewrite' => 'A|a|a|a|c|E|e|E|e|I|i|I|i|I|i|O|o|O|o|U|u|U|u|e',
		'inherit_from_clang' => 0
	),
	array(
		'original_name' => 'svensk',
		'code' => 'sv',
		'region_code' => 'sv-SE',
		'url_slug' => 'sv',
		'hreflang' => 'sv',
		'dir' => 'ltr',
		'rewrite_mode' => SEO42_REWRITEMODE_SPECIAL_CHARS,
		'special_chars' => 'Å|å|Ä|ä|Ö|ö|&',
		'special_chars_rewrite' => 'A|a|Oe|oe|Ae|ae|och',
		'inherit_from_clang' => 0
	),
);

